#include "main.h"

int setConfig () {

	char buffer[101];
	int fd = 0, fd2 = 0, bytes;

	// attempt to create the config file
	if ((fd = open (CONFIG, O_WRONLY | O_CREAT | O_EXCL)) < 0) {
		printf ("\n(Config. file already exists!)");

		// config file exists, so open it
		fd = open (CONFIG, O_RDONLY);

		printf ("\nRenaming existing configuration file to \"%s\"...", CONFIGOLD);
		// check whether backup file already exists. if it exists, truncate
		// the file (atomic operation)
		if ((fd2 = open (CONFIGOLD, O_WRONLY | O_CREAT | O_EXCL)) < 0) {
			fd2 = open (CONFIGOLD, O_WRONLY | O_CREAT | O_TRUNC);
		}

		// set permissions on new backup file
		fchmod (fd2, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);

		// copy file into ppp.conf.old
		while ((bytes = read (fd, buffer, 100)) > 0) {
			write (fd2, buffer, bytes);
		}

		close (fd);

		// truncate ppp.conf
		fd = open (CONFIG, O_WRONLY | O_TRUNC);

		close (fd);
		close (fd2);

		printf ("done");
	} else {
		// set permissions on new config file
		fchmod (fd, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
	}

//	printf ("\nerror number: %d\n\n", errno);
	return (fd);
}

void writeConfig ( int isStatic, char *IP, int fd, char *device, char *number, char *username, char *password, int isReconnect, char *reconnectDelay, char *reconnectTimes ) {

	FILE *fp;

	// open config file for writing, using stream
	// not using the fd passed in because there are
	// core dump problems with it

	printf ("\nWriting new configuration file...");
	fp = fopen (CONFIG, "w");
//	fp = fdopen (fd, "w+");

	fprintf (fp, "default:\n");
	fprintf (fp, " set log phase chat connect LCP IPCP CCP tun command\n");
	fprintf (fp, " set device %s\n", device); 
	fprintf (fp, " set speed 115200\n");
	fprintf (fp, " deny lqr\n");
//	fprintf (fp, " set dial \"%s\"\n\n", SCRIPT);
	fprintf (fp, " set dial \"ABORT BUSY ABORT NO\\\\sCARRIER TIMEOUT 5 \\\"\\\" AT OK \\\\dATDT\\\\T TIMEOUT 40 CONNECT\"\n\n");
	fprintf (fp, "connect:\n");
	fprintf (fp, " set phone %s \n", number);
	fprintf (fp, " set login \"TIMEOUT 5 login:--login: %s word: %s\"\n", username, password);
	fprintf (fp, " set timeout 0\n");

	if (isReconnect) {
		fprintf (fp, " set reconnect %s %s\n", reconnectDelay, reconnectTimes);
		fprintf (fp, " set redial %s %s\n", reconnectDelay, reconnectTimes);
	}
	
	if (isStatic) {
		fprintf (fp, " set ifaddr %s 10.0.0.1/0 0.0.0.0 0.0.0.0\n", IP);
		fprintf (fp, " add default HISADDR\n");
	}
	else {
		fprintf (fp, " set ifaddr 10.0.0.1/0 10.0.0.2/0 255.255.255.0\n");
		fprintf (fp, " delete ALL\n");
		fprintf (fp, " add 0 0 HISADDR\n");
	}
	printf("done\n");
}
